#!/bin/bash

### Keras/Pytorch/ONNX Accelerator Design Flow ###

# mlp3layers example

# This prebuilt ESP design is configured as follows:
# BOARD = xilinx-vcu118-xcvu9p
# FPGA_HOST = localhost
# XIL_HW_SERVER_PORT = 3121
# ESPLink IP address = 192.168.1.11

# Warning: running ESP Make targets can overwrite or delete these images.
# Usage: ./runme.sh [mlp3layers]"

target=linux.bin

if [ "$1" == "barec" ]; then
    target=barec/mlp3layers.bin
fi

# Use ESP Makefile
# make fpga-program

# Use standalone script
vivado -mode batch -quiet -notrace -source vivado/program.tcl -tclargs localhost 3121 xcvu9p top.bit
sleep 5

# Recompile esplink if FPGA is connected through a router as a gateway
# (please export ESPLINK_IP and ESPLINK_PORT variables before compiling)
# make esplink

./esplink --reset
./esplink --brom -i prom.bin
./esplink --dram -i $target
./esplink --reset
